<template>
  <div id="lecture_item_from_bank_wrapper" class="bt-container">
    <!--뒤로가기 추가-->
    <div style="display:inline; float: right; margin-top:40px; margin-bottom:40px;">
      <a href="javascript:history.back();">
        <el-button size="small">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
      </a>
    </div>      
    <h2>{{ $t('ITEM.FROM_BANK') }}</h2>   
    <div style="height: 10px;" />
    <el-tabs type="card" @tab-click="onClick('TAB_CHANGE')">
      <el-tab-pane :label="$t('ITEM_FROM_BANK.SEARCH_NAME')">
        <el-select v-model="selectType" :placeholder="$t('ITEM_FROM_BANK.SELECT_TYPE')">
          <el-option v-for="item in typelist" :key="item" :label="item" :value="item"></el-option>
        </el-select>
        <el-input :placeholder="$t('ITEM_FROM_BANK.SEARCH_NAME')" prefix-icon="el-icon-search" v-model="searchName" style="width: 300px;"></el-input>
        <el-button type="primary" @click="onClick('SEARCH_BY_NAME')">{{ $t('ITEM_FROM_BANK.SEARCH') }}</el-button>
        <el-button @click="onClick('INIT_RESULT')">{{ $t('ITEM_FROM_BANK.REFRESH') }}</el-button>
      </el-tab-pane>
      <el-tab-pane :label="$t('ITEM_FROM_BANK.SEARCH_GROUP')">
        <el-select v-model="selectType" :placeholder="$t('ITEM_FROM_BANK.SELECT_TYPE')">
          <el-option v-for="item in typelist" :key="item" :label="item" :value="item"></el-option>
        </el-select>
        <el-select v-model="selectGroup" :placeholder="$t('ITEM_FROM_BANK.SELECT_GROUP')">
          <el-option v-for="item in group" :key="item.group_id" :label="item.name" :value="item.group_id"></el-option>
        </el-select>
        <el-button type="primary" @click="onClick('SEARCH_BY_GROUP')">{{ $t('ITEM_FROM_BANK.SEARCH') }}</el-button>
        <el-button @click="onClick('INIT_RESULT')">{{ $t('ITEM_FROM_BANK.REFRESH') }}</el-button>
      </el-tab-pane>
      <el-tab-pane :label="$t('ITEM_FROM_BANK.SEARCH_KEYWORD')">
        <el-input :placeholder="$t('BANK.SEARCH_KEYWORD')" prefix-icon="el-icon-search" v-model="searchKey" style="width: 300px;"></el-input>
        <el-button @click="onClick('NEW_KEYWORD', searchKey)">{{ $t('ITEM_FROM_BANK.ADD_KEY') }}</el-button>
        <br />
        <div style="height: 10px;" />
        <el-select v-model="selectType" :placeholder="$t('ITEM_FROM_BANK.SELECT_TYPE')">
          <el-option v-for="item in typelist" :key="item" :label="item" :value="item"></el-option>
        </el-select>
        <el-tag v-for="(value, index) in searchKeywordList" :key="value" closable @close="deleteKeyword(index)" style="margin-right: 5px;">{{ value }}</el-tag>
        <el-button type="primary" @click="onClick('SEARCH_BY_KEYWORD')">{{ $t('ITEM_FROM_BANK.SEARCH') }}</el-button>
        <el-button @click="onClick('INIT_RESULT')">{{ $t('ITEM_FROM_BANK.REFRESH') }}</el-button>
      </el-tab-pane>
    </el-tabs>
    <div style="height: 50px;" />
    <el-table ref="multipleTable" :data="resultLectureItemList" style="width: 100%" @selection-change="handleSelectionChange" max-height="800">
      <el-table-column
        type="selection"
        width="55"> 
      </el-table-column>
      <el-table-column :label="$t('ITEM_FROM_BANK.ITEM_NAME')">
        <template slot-scope="scope">{{ scope.row.name }}</template>
      </el-table-column>
      <el-table-column :label="$t('LECTURE_LIST.TYPE')">
        <!-- <template slot-scope="scope">{{ scope.row.typename }}</template> -->
        <template slot-scope="scope">
          <span v-if="scope.row.typename === '문항'">{{ $t('ITEM.QUESTION') }}</span>
          <span v-else-if="scope.row.typename === '설문'">{{ $t('ITEM.SURVEY') }}</span>
          <span v-else-if="scope.row.typename === '실습'">{{ $t('PRACTICE.PRACT_ITEM') }}</span>
          <span v-else-if="scope.row.typename === '자료'">{{ $t('ITEM.NOTE') }}</span>
          <span v-else-if="scope.row.typename === '토론'">{{ $t('ITEM.DISCUSSION') }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('BANK.GROUP')">
        <template slot-scope="scope">{{ scope.row.groupName }}</template>
      </el-table-column>
      <!--<el-table-column label="저작일">
        <template slot-scope="scope">{{ scope.row.createTime }}</template>
      </el-table-column>
      <el-table-column label="최종 수정일">
        <template slot-scope="scope">{{ scope.row.updateTime }}</template>
      </el-table-column>-->
    </el-table>
    <div style="height: 10px;" />
    <div style="text-align: right;">
      <el-button type="primary" @click="onClick('BRING_LECTURE_ITEM')">{{ $t('ITEM_FROM_BANK.IMPORT') }}</el-button>
    </div>
  </div>
</template>

<script>
import { mapMutations } from 'vuex';
import bankService from '../../services/bankService';
import classService from '../../services/classService';

export default {
  name: 'NLectureFromBank',
  data() {
    return {
      isAdd: false,
      searchName: '',
      selectGroup: '',
      searchKey: '',
      searchKeywordList: [],
      multipleSelection: [],
      group: [],
      resultLectureItemList: [],
      bankLectureItemList: [],
      typelist: [this.$t('ITEM_FROM_BANK.WHOLE'), this.$t('ITEM.QUESTION'), this.$t('ITEM.SURVEY'), this.$t('PRACTICE.PRACT_ITEM'), this.$t('ITEM.NOTE'), this.$t('ITEM.DISCUSSION')],
      selectType: '',
      classType: '',
    };
  },
  computed: {
    lectureId() {
      const vm = this;
      return Number.parseInt(vm.$route.query.lectureId, 10);
    },
  },
  async mounted() {
    const vm = this;
    vm.isAdd = false;
    // 실습과목인지 일반과목인지
    const classId = Number.parseInt(vm.$route.query.classId, 10);
    const classInfo = await classService.getClass({
      id: classId,
    });
    vm.classType = classInfo.data.practice; // 0은 일반과목, 1은 실습과목
    const res = await bankService.getBankLectureItem({
      type: 'question',
    });
    res.data.lectureItemList.forEach((x) => {
      const lectureItemInfo = {};
      lectureItemInfo.name = x.name;
      lectureItemInfo.type = x.type;
      lectureItemInfo.typename = '문항';
      lectureItemInfo.id = x.lecture_item_id;
      lectureItemInfo.groupId = x.bank_group.group_id;
      lectureItemInfo.groupName = x.bank_group.name;
      vm.bankLectureItemList.push(lectureItemInfo);
    });
    vm.resultLectureItemList = vm.bankLectureItemList;
    const res1 = await bankService.getBankLectureItem({
      type: 'survey',
    });
    res1.data.lectureItemList.forEach((x) => {
      const lectureItemInfo = {};
      lectureItemInfo.name = x.name;
      lectureItemInfo.type = x.type;
      lectureItemInfo.typename = '설문';
      lectureItemInfo.id = x.lecture_item_id;
      lectureItemInfo.groupId = x.bank_group.group_id;
      lectureItemInfo.groupName = x.bank_group.name;
      vm.bankLectureItemList.push(lectureItemInfo);
    });
    vm.resultLectureItemList = vm.bankLectureItemList;
    if (vm.classType === 1) {
      const res2 = await bankService.getBankLectureItem({
        type: 'codepractice',
      });
      res2.data.lectureItemList.forEach((x) => {
        const lectureItemInfo = {};
        lectureItemInfo.name = x.name;
        lectureItemInfo.type = x.type;
        lectureItemInfo.typename = '실습';
        lectureItemInfo.id = x.lecture_item_id;
        lectureItemInfo.groupId = x.bank_group.group_id;
        lectureItemInfo.groupName = x.bank_group.name;
        vm.bankLectureItemList.push(lectureItemInfo);
      });
      vm.resultLectureItemList = vm.bankLectureItemList;
    }
    const res3 = await bankService.getBankLectureItem({
      type: 'discussion',
    });
    res3.data.lectureItemList.forEach((x) => {
      const lectureItemInfo = {};
      lectureItemInfo.name = x.name;
      lectureItemInfo.type = x.type;
      lectureItemInfo.typename = '토론';
      lectureItemInfo.id = x.lecture_item_id;
      lectureItemInfo.groupId = x.bank_group.group_id;
      lectureItemInfo.groupName = x.bank_group.name;
      vm.bankLectureItemList.push(lectureItemInfo);
    });
    vm.resultLectureItemList = vm.bankLectureItemList;
    const res4 = await bankService.getBankLectureItem({
      type: 'note',
    });
    res4.data.lectureItemList.forEach((x) => {
      const lectureItemInfo = {};
      lectureItemInfo.name = x.name;
      lectureItemInfo.type = x.type;
      lectureItemInfo.typename = '자료';
      lectureItemInfo.id = x.lecture_item_id;
      lectureItemInfo.groupId = x.bank_group.group_id;
      lectureItemInfo.groupName = x.bank_group.name;
      vm.bankLectureItemList.push(lectureItemInfo);
    });
    vm.resultLectureItemList = vm.bankLectureItemList;
    if (vm.classType === 1) { // 실습 과목일 경우에만 코딩 과제
      const res5 = await bankService.getBankLectureItem({
        type: 'homework',
      });
      res5.data.lectureItemList.forEach((x) => {
        const lectureItemInfo = {};
        lectureItemInfo.name = x.name;
        lectureItemInfo.type = x.type;
        lectureItemInfo.typename = '코딩 과제';
        lectureItemInfo.id = x.lecture_item_id;
        lectureItemInfo.groupId = x.bank_group.group_id;
        lectureItemInfo.groupName = x.bank_group.name;
        vm.bankLectureItemList.push(lectureItemInfo);
      });
      vm.resultLectureItemList = vm.bankLectureItemList;
    }
    // 내 그룹 받아오기
    const myg = await bankService.getMyGroup();
    vm.group = myg.data.groupList;
  },
  methods: {
    ...mapMutations('lectureEditTab', [
      'updateTab',
    ]),
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    goBack() {
      const vm = this;
      vm.updateTab({
        tab: 'item',
      });
      window.history.back();
    },
    async onClick(type) {
      const vm = this;
      switch (type) {
        // 탭 변경
        case 'TAB_CHANGE': {
          vm.searchName = '';
          vm.searchKey = '';
          vm.selectGroup = '';
          vm.selectType = '';
          vm.searchKeywordList = [];
          vm.$refs.multipleTable.clearSelection();
          break;
        }
        // 아이템명으로 검색
        case 'SEARCH_BY_NAME': {
          if (vm.searchName === '') {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ENTER_ITEM_NAME'),
              type: 'warning',
            });
            break;
          }
          if (vm.selectType === '') {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.SLCT_ITEM_TYPE'),
              type: 'warning',
            });
            break;
          }
          vm.resultLectureItemList = [];
          if (vm.selectType === vm.$t('ITEM_FROM_BANK.WHOLE')) {
            vm.resultLectureItemList = [];
            const res = bankService.getBankLectureItemByName({
              type: 'question',
              name: vm.searchName,
            });
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '문항';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
            const res1 = bankService.getBankLectureItemByName({
              type: 'codepractice',
              name: vm.searchName,
            });
            res1.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '실습';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
            const res2 = bankService.getBankLectureItemByName({
              type: 'survey',
              name: vm.searchName,
            });
            res2.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '설문';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
            const res3 = bankService.getBankLectureItemByName({
              type: 'discussion',
              name: vm.searchName,
            });
            res3.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '토론';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
            const res4 = bankService.getBankLectureItemByName({
              type: 'note',
              name: vm.searchName,
            });
            res4.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '자료';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          } else if (vm.selectType === vm.$t('ITEM.QUESTION')) {
            const res = bankService.getBankLectureItemByName({
              type: 'question',
              name: vm.searchName,
            });
            vm.resultLectureItemList = [];
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '문항';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          } else if (vm.selectType === vm.$t('PRACTICE.PRACT_ITEM')) {
            const res = bankService.getBankLectureItemByName({
              type: 'codepractice',
              name: vm.searchName,
            });
            vm.resultLectureItemList = [];
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '실습';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          } else if (vm.selectType === vm.$t('ITEM.SURVEY')) {
            const res = bankService.getBankLectureItemByName({
              type: 'survey',
              name: vm.searchName,
            });
            vm.resultLectureItemList = [];
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '설문';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          } else if (vm.selectType === vm.$t('ITEM.DISCUSSION')) {
            const res = bankService.getBankLectureItemByName({
              type: 'discussion',
              name: vm.searchName,
            });
            vm.resultLectureItemList = [];
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '토론';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          } else if (vm.selectType === vm.$t('ITEM.NOTE')) {
            const res = bankService.getBankLectureItemByName({
              type: 'note',
              name: vm.searchName,
            });
            vm.resultLectureItemList = [];
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '자료';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          }
          break;
        }
        // 소속 그룹으로 검색
        case 'SEARCH_BY_GROUP': {
          if (vm.selectGroup === '') {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.SLCT_GRP'),
              type: 'warning',
            });
            break;
          }
          if (vm.selectType === '') {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.SLCT_ITEM_TYPE'),
              type: 'warning',
            });
            break;
          }
          vm.resultLectureItemList = [];
          if (vm.selectType === vm.$t('ITEM_FROM_BANK.WHOLE')) {
            vm.resultLectureItemList = [];
            const res = bankService.getBankLectureItemByGroup({
              type: 'question',
              id: vm.selectGroup,
            });
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '문항';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
            const res1 = bankService.getBankLectureItemByGroup({
              type: 'codepractice',
              id: vm.selectGroup,
            });
            res1.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '실습';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
            const res2 = bankService.getBankLectureItemByGroup({
              type: 'survey',
              id: vm.selectGroup,
            });
            res2.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '설문';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
            const res3 = bankService.getBankLectureItemByGroup({
              type: 'discussion',
              id: vm.selectGroup,
            });
            res3.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '토론';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
            const res4 = bankService.getBankLectureItemByGroup({
              type: 'note',
              id: vm.selectGroup,
            });
            res4.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '자료';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          } else if (vm.selectType === vm.$t('ITEM.QUESTION')) {
            const res = bankService.getBankLectureItemByGroup({
              type: 'question',
              id: vm.selectGroup,
            });
            vm.resultLectureItemList = [];
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '문항';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          } else if (vm.selectType === vm.$t('PRACTICE.PRACT_ITEM')) {
            const res = bankService.getBankLectureItemByGroup({
              type: 'codepractice',
              id: vm.selectGroup,
            });
            vm.resultLectureItemList = [];
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '실습';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          } else if (vm.selectType === vm.$t('ITEM.SURVEY')) {
            const res = bankService.getBankLectureItemByGroup({
              type: 'survey',
              id: vm.selectGroup,
            });
            vm.resultLectureItemList = [];
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '설문';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          } else if (vm.selectType === vm.$t('ITEM.DISCUSSION')) {
            const res = bankService.getBankLectureItemByGroup({
              type: 'discussion',
              id: vm.selectGroup,
            });
            vm.resultLectureItemList = [];
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '토론';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          } else if (vm.selectType === vm.$t('ITEM.NOTE')) {
            const res = bankService.getBankLectureItemByGroup({
              type: 'note',
              id: vm.selectGroup,
            });
            vm.resultLectureItemList = [];
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '자료';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          }
          break;
        }
        // 검색할 키워드 추가
        case 'NEW_KEYWORD': {
          // 빈 키워드 입력
          if (vm.searchKey === '') {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ENTER_KYWRD'),
              type: 'warning',
            });
            break;
          }
          // 키워드 추가시 중복 검사
          if (vm.searchKeywordList.includes(vm.searchKey) === true) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ALRDY_ADDED_KEY'),
              type: 'warning',
            });
            break;
          }
          // 중복이 아닐 경우 검색 목록에 추가
          vm.searchKeywordList.push(vm.searchKey);
          vm.searchKey = '';
          break;
        }
        // 입력한 키워드들로 검색
        case 'SEARCH_BY_KEYWORD': {
          // 키워드가 없으면 검색이 되지 않음
          if (vm.searchKeywordList.length === 0) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ADD_KEY'),
              type: 'warning',
            });
            break;
          }
          if (vm.selectType === '') {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.SLCT_ITEM_TYPE'),
              type: 'warning',
            });
            break;
          }
          vm.resultLectureItemList = [];
          if (vm.selectType === vm.$t('ITEM_FROM_BANK.WHOLE')) {
            const res = bankService.getBankLectureItemByKeyword({
              type: 'question',
              keyArray: vm.searchKeywordList,
            });
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '문항';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
            const res1 = bankService.getBankLectureItemByKeyword({
              type: 'codepractice',
              keyArray: vm.searchKeywordList,
            });
            res1.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '실습';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
            const res2 = bankService.getBankLectureItemByKeyword({
              type: 'survey',
              keyArray: vm.searchKeywordList,
            });
            res2.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '설문';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
            const res3 = bankService.getBankLectureItemByKeyword({
              type: 'discussion',
              keyArray: vm.searchKeywordList,
            });
            res3.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '토론';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
            const res4 = bankService.getBankLectureItemByKeyword({
              type: 'note',
              keyArray: vm.searchKeywordList,
            });
            res4.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '자료';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          } else if (vm.selectType === vm.$t('ITEM.QUESTION')) {
            const res = bankService.getBankLectureItemByKeyword({
              type: 'question',
              keyArray: vm.searchKeywordList,
            });
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '문항';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          } else if (vm.selectType === vm.$t('PRACTICE.PRACT_ITEM')) {
            const res = bankService.getBankLectureItemByKeyword({
              type: 'codepractice',
              keyArray: vm.searchKeywordList,
            });
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '실습';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          } else if (vm.selectType === vm.$t('ITEM.SURVEY')) {
            const res = bankService.getBankLectureItemByKeyword({
              type: 'survey',
              keyArray: vm.searchKeywordList,
            });
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '설문';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          } else if (vm.selectType === vm.$t('ITEM.DISCUSSION')) {
            const res = bankService.getBankLectureItemByKeyword({
              type: 'discussion',
              keyArray: vm.searchKeywordList,
            });
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '토론';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          } else if (vm.selectType === vm.$t('ITEM.NOTE')) {
            const res = bankService.getBankLectureItemByKeyword({
              type: 'note',
              keyArray: vm.searchKeywordList,
            });
            res.then(function(sre) {  // eslint-disable-line
              sre.data.lectureItemList.forEach((x) => {
                const lectureItemInfo = {};
                lectureItemInfo.name = x.name;
                lectureItemInfo.type = x.type;
                lectureItemInfo.typename = '자료';
                lectureItemInfo.id = x.lecture_item_id;
                lectureItemInfo.groupId = x.bank_group.group_id;
                lectureItemInfo.groupName = x.bank_group.name;
                vm.resultLectureItemList.push(lectureItemInfo);
              });
            });
          }
          break;
        }
        // 검색 결과 초기화  & 선택 내용 초기화
        case 'INIT_RESULT': {
          vm.searchName = '';
          vm.selectGroup = '';
          vm.searchKey = '';
          vm.searchKeywordList = [];
          vm.selectType = '';
          vm.resultLectureItemList = vm.bankLectureItemList;
          vm.$refs.multipleTable.clearSelection();
          break;
        }
        // 선택된 강의 아이템들 가져오기
        case 'BRING_LECTURE_ITEM': {
          // 선택된 강의 아이템이 없을 경우
          if (vm.multipleSelection.length === 0) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.NO_ITEM_SLCTED'),
              type: 'warning',
            });
            break;
          }
          let i = 0;
          for (i = 0; i < vm.multipleSelection.length; i += 1) {
            const x = vm.multipleSelection[i];
            const classId = Number.parseInt(vm.$route.query.classId, 10);
            await bankService.bankToLectureItem({ // eslint-disable-line
              lecture_item_id: x.id,
              target_lecture_id: vm.lectureId,
              class_id: classId,
            });
          }
          vm.$notify({
            title: vm.$t('NOTIFY.TITLE'),
            message: vm.$t('NOTIFY.SCS_IMPR_CRS_ITEM'),
            type: 'success',
          });
          break;
        }
        // 아이템 미리보기의 제출 버튼
        case 'SUBMIT': {
          vm.$notify({
            title: vm.$t('NOTIFY.TITLE'),
            message: vm.$t('NOTIFY.BTN_ONLY_ENR_STD'),
            type: 'warning',
          });
          break;
        }
        // 뒤로 가기
        case 'BACK': {
          break;
        }
        default: {
          break;
        }
      }
    },
    // 추가한 키워드 삭제
    deleteKeyword(arg) {
      const vm = this;
      vm.searchKeywordList.splice(arg, 1);
    },
  },
};
</script>

